/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Certificate ID print
*/

CREATE PROCEDURE [dbo].[SP_DLV_INV_CertificatePrint]
	--@InvoiceNos varchar(max),
	--@InvoiceDates varchar(max),
	--@lp_codes varchar(max)
		@Grid VARCHAR (MAX)
AS
BEGIN

		--DECLARE @InvoiceDates varchar(max) = '20131101,20131030,';
		--DECLARE @SupplierCodes VARCHAR (6) = '5021,1153';

		CREATE TABLE #CERTIFICATE_PRINT(
			LP_INV_NO VARCHAR(30),
			INV_DT VARCHAR (11),
			INVOICE_AMOUNT NUMERIC(16,2),
			SUPPLIER_CD VARCHAR(MAX),
			INV_TAX_NO VARCHAR(24),
			CURRENCY_CD VARCHAR(3),
			CERTIFICATE_ID VARCHAR(26),
			CERTIFICATE_ID_ACCEPT VARCHAR(26),
			CERTIFICATE_ID_REJECT VARCHAR(26),
			INV_TAX_DATE VARCHAR (11),
			TOTAL_AMOUNT NUMERIC(16,5),
			--AMOUNT_BEFORE NUMERIC(16,5),
			INV_TAX_AMOUNT NUMERIC(16,5),
			--,TURN_OVER NUMERIC(16,2)
			DELIVERY_NO VARCHAR (13),
			SUBMIT_BY VARCHAR (20),
			SUBMIT_DT VARCHAR (11),
			MANUAL_ENTRY CHAR(1)
		)
		
		DECLARE @x XML;
		SET @x = '<r>' + REPLACE((SELECT @Grid FOR XML PATH('')), ',', '</r><r>') + '</r>';


						INSERT INTO #CERTIFICATE_PRINT


						SELECT 
						qry.LP_INV_NO AS LP_INV_NO,
						REPLACE( CONVERT (varchar (11),qry.INV_DT, 104), '/','.') AS INV_DT, 
						SUM(qry.INVOICE_AMOUNT) AS INVOICE_AMOUNT,
						MAX(qry.SUPPLIER_CD) AS SUPPLIER_CD,
						MAX(qry.INV_TAX_NO) AS INV_TAX_NO,
						MAX(qry.CURRENCY_CD) AS CURRENCY_CD,  
						MAX(qry.CERTIFICATE_ID) AS CERTIFICATE_ID,
						MAX(qry.CERTIFICATE_ID_ACCEPT) AS CERTIFICATE_ID_ACCEPT,
						MAX(qry.CERTIFICATE_ID_REJECT) AS CERTIFICATE_ID_REJECT,
						REPLACE( CONVERT (varchar (11), MAX(qry.INV_TAX_DATE), 104), '/','.') AS INV_TAX_DATE,
						
						
						SUM(qry.TOTAL_AMOUNT) + SUM(qry.INV_TAX_AMOUNT) AS TOTAL_AMOUNT,
						--SUM(qry.AMOUNT_BEFORE) AS AMOUNT_BEFORE,
						SUM(qry.INV_TAX_AMOUNT) AS INV_TAX_AMOUNT,
						MAX (qry.DELIVERY_NO) AS DELIVERY_NO,
						(SELECT FULL_NAME FROM TB_R_VW_EMPLOYEE WHERE USERNAME = MAX (qry.SUBMIT_BY)) AS SUBMIT_BY, 
						REPLACE( CONVERT (VARCHAR (11),MAX(qry.SUBMIT_DT),104), '/','.') AS SUBMIT_DT
						--,MAX(qry.TURN_OVER) AS TURN_OVER
						--SUM(qry.AMOUNT_BEFORE) AS AMOUNT_BEFORE,
						--SUM(qry.TAX_AMOUNT) AS TOTAL_AMOUNT, 
						--SUM(qry.TAX_AMOUNT)-SUM(qry.AMOUNT_BEFORE) AS INV_TAX_AMOUNT,
						, qry.MANUAL_ENTRY
						 FROM
						(SELECT	

								LP_INV_NO=tu.[LP_INV_NO]
								
								,INV_DT=MAX(tu.[INV_DT])
								,INVOICE_AMOUNT=MAX(ISNULL(tu.INV_AMT,0))
								,SUPPLIER_CD=MAX(tu.LP_CD + ' - ' + lp.LOG_PARTNER_NAME)
								,INV_TAX_NO=MAX(tu.[INV_TEXT])
								,CURRENCY_CD=MAX(tu.CURR_CD)
								,CERTIFICATE_ID=MAX(tu.[CERTIFICATE_ID])
								,CERTIFICATE_ID_ACCEPT=MAX('A')
								,CERTIFICATE_ID_REJECT=MAX('R')
								,[INV_TAX_DATE]=MAX(INV_TAX_DT)
								,INV_TAX_AMOUNT=MAX(ISNULL(tu.INV_TAX_AMT,0))
								,TOTAL_AMOUNT = SUM (tu.INV_AMT)
								,DELIVERY_NO = tu.DELIVERY_NO
								,SUBMIT_BY = MAX (tu.SUBMIT_BY)
								,SUBMIT_DT = MAX(tu.SUBMIT_DT)
								--,TURN_OVER=MAX(ISNULL(tu.PRICE_AMT,0))+ISNULL(SUM(ISNULL(tu.INV_AMT,0)),0)
								,MANUAL_ENTRY = ISNULL(vat.MANUAL_ENTRY, 'N') 
								FROM TB_R_DLV_INV_UPLOAD tu
								INNER JOIN TB_M_LOGISTIC_PARTNER lp ON tu.LP_CD=lp.LOG_PARTNER_CD
								INNER JOIN TB_M_INV_STATUS st ON tu.STATUS_CD=st.STATUS_CD

								INNER JOIN [TMMIN_E_FAKTUR].[dbo].TB_R_VAT_IN_H VAT ON tu.[INV_TEXT] = VAT.SAP_TAX_INVOICE_NO --add fid.deny to get MANUAL_ENTRY value


								LEFT JOIN TB_R_DLV_INV_H INVH ON INVH.INV_NO=tu.INV_NO
								LEFT JOIN TB_R_DLV_GR_IR GRIR ON GRIR.INV_NO=tu.INV_NO

								WHERE 
									VAT.REPLACEMENT_FG = (SELECT MAX(VATT.REPLACEMENT_FG) FROM [TMMIN_E_FAKTUR].[dbo].TB_R_VAT_IN_H VATT WHERE VATT.SAP_TAX_INVOICE_NO = tu.INV_TEXT) AND
									--tu.LP_INV_NO = @INV_NO
									tu.LP_INV_NO+CAST(SEQ_NO AS VARCHAR) IN (SELECT  y.XmlCol.value('(text())[1]', 'VARCHAR(1000)') AS Value FROM    @x.nodes('/r') y(XmlCol))
									AND tu.LP_CD=VAT.SUPPLIER_CODE
									--AND tu.STATUS_CD='2'
									--AND
									--tu.[INV_DT] = @INV_DT AND
									--CONVERT(VARCHAR(11), tu.[INV_DT], 101) = CONVERT(VARCHAR(11), @INV_DT, 111) AND
									--CONVERT(VARCHAR(11), tu.[INV_DT], 101) = @INV_DT AND
									--tu.LP_CD=@LP_CD



								GROUP BY tu.[LP_INV_NO],tu.LP_CD, tu.ROUTE_CD, tu.DELIVERY_NO, vat.MANUAL_ENTRY

						) qry
						GROUP BY qry.LP_INV_NO, qry.INV_DT, qry.SUPPLIER_CD, qry.MANUAL_ENTRY

						
					SELECT * FROM #CERTIFICATE_PRINT

		
END

